
#import "RulePanel.h"
#import "nxlcau41.h"
#import <string.h>
#import <time.h>
#import "rec.h"

extern char arule[DS], arr1[AL], arr2[AL], arr3[AL];
extern char ascrule[KK][KK][KK];
extern char auxrule[KK][KK][KK];
extern char gf3rule[13];		/* coefficients of GF3 rule	*/
extern char ttrule[TS];			/* totalistic rule		*/
extern char tarule[TS];
extern char strule[KK][SS];		/* semitoralistic rule		*/
extern char sarule[KK][SS];

extern char   prule1[8], prule2[8];	   /* product rule specification */
extern char   prule3[8];	   	   /* coev rule specification    */
extern char   evrule[2][2][2][2];	   /* evolutionary rule 	 */
extern char   bhrul1[2][2], bhrul2[2][3];  /* binary r=1/2 rule #1,2 	 */

extern birular binrule;

extern NXColor colst[KK];

extern struct fptbl dtbl[];
extern Inst   xprg[][XLEN];
extern char   idef[][30];

int     allperm(char wn[][WNML], char ii[][KK][KK][KK], char ru[KK][KK][KK]);
void    asctobin();
void	asczero();
void	auxzero();
void    bintoasc();
void    chrucopy(char ii[KK][KK][KK], char jj[KK][KK][KK], int c);
void    clumin(char *c);
int     cyy(int i);
int     czz(int i);
int     fli(int i);
void    gftoasc();
void    gfzero();
void 	granprule();
void 	granrule();
int     istot();
int     isstot();
int     longwolftoasc(char *c);
void    oxtoasc(char *r);
int     permut(int k, int n);
void    perry(int n);
void    ptedbrul(birular *pr, birular *br, int k);
int     ran2of3(int a, int b);
int     ran3of3(int a, int b, int c);
void    ranblin(double p0, double p1, double p2, double p3);
void    ranvachrul(char *c);
int     runowors(int ru[3][3][3], char *c); 
void	runowows(char x[2][2][2], int n);
void	sttoasc();
void    stzero();
void	totoasc();
int     totonu(int i);
void    ttzero();
int     vecperm(int ii[KK], int n);
void    wolnum(char ii[KK][KK][KK], int c);
void    wru(char *c);
void    wrru(char *c, char ru[KK][KK][KK]);
void	xtoasc(char a[], int n);
int     ycc(int i);
int     zcc(int i);

int permu[RSYM/2][KK] = {
	{0, 1, 2, 3},
	{1, 2, 3, 0},
	{2, 3, 0, 1},
	{3, 0, 1, 2},

	{1, 2, 0, 3},
	{2, 3, 1, 0},
	{3, 0, 2, 1},
	{0, 1, 3, 2},

	{2, 0, 1, 3},
	{3, 1, 2, 0},
	{0, 2, 3, 1},
	{1, 3, 0, 2},


	{1, 0, 2, 3},
	{2, 1, 3, 0},
	{3, 2, 0, 1},
	{0, 3, 1, 2},

	{2, 1, 0, 3},
	{3, 2, 1, 0},
	{0, 3, 2, 1},
	{1, 0, 3, 2},

	{0, 2, 1, 3},
	{1, 3, 2, 0},
	{2, 0, 3, 1},
	{3, 1, 0, 2}
	};

int    perul;				/* Perry's Rule selection */

char    xr[DS] = "121220101221200000101000100";
char    xp[DS] = "532337242335361411252611214"; /* xenophilic	*/
char    xq[DS] = "135337575337326766575766564"; /* xenophobic	*/
char    xs[DS] = "135135135326326326564564564"; /* s-xenophobic */
char	xt[DS] = "642642642451451451213213213"; /* s-xenophilic	*/

@implementation RulePanel

/* - - - - - S P E C I A L   R U L E   B O X   M A N A G E M E N T - - - - - */

- loadSpecialRule:sender {char *ch;
  ch=[[sender selectedCell] title];
  if (strcmp(ch,"arithmetic")==0)  [self loadLowerPanel: arithmRuleBox];
  if (strcmp(ch,"composite")==0)   [self loadLowerPanel: compRuleBox];
  if (strcmp(ch,"equivalence")==0) [self loadLowerPanel: equivRuleBox];
  if (strcmp(ch,"product")==0)     [self loadLowerPanel: prodRuleBox];
  if (strcmp(ch,"subset")==0)      [self loadLowerPanel: subsetRuleBox];
  if (strcmp(ch,"reversible")==0)  [self loadLowerPanel: fredknRuleBox];
return self;
}

- loadLowerPanel:thisRuleBox 
{NXRect bxRect, loRect;
  [specBigBox getFrame: &bxRect];
  [thisRuleBox getFrame: &loRect];
  [specLilBox setContentView: [thisRuleBox contentView]];
  loRect.origin.x=(bxRect.size.width-loRect.size.width)/2.0;
  loRect.origin.y=(bxRect.size.height-loRect.size.height)/2.0;
  [specLilBox setFrame: &loRect];
  [specBigBox display];
  [specLilBox display];
return self;
}

- windowDidBecomeKey:sender {
	nowBox=NULL;
	[menuCopy setTarget: self];
  if (sender==mainWindow) nowBox=ruleBox;
  if (sender==speshPanel) nowBox=nowSpesh;
  if (sender==infoPanel)  nowBox=sender;
	[menuCopy setAction: @selector(copyBox:)];
	[menuCopy setEnabled: YES];
	[menuPrint setTarget: sender];
	[menuPrint setAction: @selector(smartPrintPSCode:)];
	[menuPrint setEnabled: YES];
return self;
}

- windowDidResignKey:sender {
 	[menuCopy setEnabled: NO];
 	[menuPrint setEnabled: NO];
return self;
}

- copyBox:sender {
NXRect zbounds;
id     pBoard;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [[nowBox contentView] getBounds: &zbounds];
  [[nowBox contentView] writePSCodeInside: &zbounds to: pBoard]; 
return self;
}

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

/* - - - - - - - - - - - - -   R U L E   P A N E L   - - - - - - - - - - - - */

- protectGenRule:sender
{int i, j, k, i0, i1, i2;
  i=j=[sender selectedCol];
  i2=i%KK; i/=KK;
  i1=i%KK; i/=KK;
  i0=i%KK; i/=KK;
  k=auxrule[i0][i1][i2];
  for (i=0; i<KK; i++) [[ascru cellAt: i: j] setEnabled: k];
  for (i=0; i<KK; i++) [[ascru cellAt: i: j] setBordered: k];
  auxrule[i0][i1][i2]=!k;
return self;
}

- showSymClass:sender {
char ii[RSYM][KK][KK][KK], wnum[RSYM][WNML]; int i, l;
  l=allperm(wnum,ii,ascrule);
  for (i=0; i<RSYM/2; i++) {
	[[symImages cellAt: i: 0] setStringValue: wnum[i]];
	[[symImages cellAt: i: 1] setStringValue: wnum[i+RSYM/2]];
	}
  [symMinimum setStringValue: wnum[l]];
return self;
}

- relatedRule:sender {
char ii[RSYM][KK][KK][KK], wnum[RSYM][WNML], c[WNML], *titl;
int j, k, l, jj[KK];
  l=allperm(wnum,ii,ascrule);
  titl=[[sender selectedCell] title];
       if (strcmp(titl,"4-cycle")==0)   k= 1;
  else if (strcmp(titl,"3-cycle")==0)   k= 4;
  else if (strcmp(titl,"2-cycle")==0)   k=12;
  else if (strcmp(titl,"reflect")==0)   k=24;
  else if (strcmp(titl,"cluster")==0)   k=RSYM;
  else if (strcmp(titl,"least")==0)     k= l;
  else    			        k= 0;
  if (k==RSYM) {
    clumin(c);
    longwolftoasc(c);
    [self setAllRules: self];
    return self;
    }
  chrucopy(ascrule,ii[k],'w');
  [self setAllRules: self];
  if ([changeLine state]) {
	  l=vecperm(jj,k);
	  for (j=0; j<AL; j++) arr1[j]=jj[arr1[j]];
	  if (l) {
		for (j=0; j<AL; j++) arr2[j]=arr1[AL-1-j];
		for (j=0; j<AL; j++) arr1[j]=arr2[j];
		 }
	}
return self;
}

/* fill a KK-vector ii with inverse permutation #n of its indices  */
/* inverse is because this will be used to generate configurations */
/* return TRUE if there was a reflection of the neighborhood       */
int vecperm(ii,n) int ii[KK], n;
{int i, k, l;
  l=!(n<RSYM/2); k=(l?n-RSYM/2:n);
  for (i=0; i<KK; i++) ii[i]=permu[k][i];
  return l;
}

/* generate a table of permutations of a given rule       */
/* and report the index of the rule with smallest wru     */
/* wn - array to be filled with 9-letter wolfram numbers  */
/* ii - array to be filled with ascrule symmetry images   */
/* ru - reference KK8KK8KK table - e.g. ascrule           */
/* return value is the index of the least of all these    */
/* that is, wn[...] is the number, ii[...] is the rule    */

int allperm(wn,ii,ru) char wn[][WNML], ii[][KK][KK][KK], ru[KK][KK][KK];
{int i, l, k;
chrucopy(ii[0],ru,'w');					        /* identity */
for (i=1; i<KK; i++) chrucopy(ii[i],ii[i-1],'y'); 	        /* 4-cycles */
for (i=KK; i<2*KK; i++) chrucopy(ii[i],ii[i-KK],'z');	        /* 3-cycles */
for (i=2*KK; i<3*KK; i++) chrucopy(ii[i],ii[i-KK],'z'); 	/* 3-cycles */
for (i=RSYM/4; i<RSYM/2; i++) chrucopy(ii[i],ii[i-RSYM/4],'t'); /* 2-cycles */
for (i=RSYM/2; i<RSYM; i++) chrucopy(ii[i],ii[i-RSYM/2],'r');   /* reflect  */
for (k=0, l=0; k<RSYM; k++) {
    wrru(wn[k],ii[k]);
    if (strlen(wn[k]) > strlen(wn[l])) continue;
    if (strlen(wn[k]) < strlen(wn[l])) {l=k; continue;}
    if (strcmp(wn[k],wn[l]) < 0) l=k;
    }
return l;
}

/* copy a related (character) rule */
/* c = w - no change		   */
/* c = y - cyclic permutation	   */
/* c = r - reflected		   */
/* c = t - transpose 1&2	   */

void chrucopy(ii,jj,c) char ii[KK][KK][KK], jj[KK][KK][KK], c; {
int i0, i1, i2;
  switch (c) {
    case 'w':
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
      for (i2=0; i2<KK; i2++) 
        ii[i0][i1][i2]=jj[i0][i1][i2];
      break;
    case 'y':
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
      for (i2=0; i2<KK; i2++) 
        ii[i0][i1][i2]=ycc(jj[cyy(i0)][cyy(i1)][cyy(i2)]);
      break;
    case 'z':					/* 3-cycle */
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
      for (i2=0; i2<KK; i2++) 
        ii[i0][i1][i2]=zcc(jj[czz(i0)][czz(i1)][czz(i2)]);
      break;
    case 'r':
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
      for (i2=0; i2<KK; i2++) 
        ii[i0][i1][i2]=jj[i2][i1][i0];
      break;
    case 't':
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
      for (i2=0; i2<KK; i2++) 
        ii[i0][i1][i2]=fli(jj[fli(i0)][fli(i1)][fli(i2)]);
      break;
    default: break;}
}

int fli(i) int i; {
  switch (i) {
	case '0': return '1';			/*   ascci  */
	case '1': return '0'; 
	case '2': return '2';
	case '3': return '3';
	case 0: return 1;			/*    binary */
	case 1: return 0; 
	case 2: return 2;
	case 3: return 3;
	default:  return '0';}
}

int cyy(i) int i; {
  switch (i) {
	case '0': return '1';
	case '1': return '2'; 
	case '2': return '3';
	case '3': return '0';

	case 0: return 1;
	case 1: return 2; 
	case 2: return 3;
	case 3: return 0;

	default:  return '0';}
}

int ycc(i) int i; {
  switch (i) {
	case '0': return '3';
	case '1': return '0'; 
	case '2': return '1';
	case '3': return '2';

	case 0: return 3;
	case 1: return 0; 
	case 2: return 1;
	case 3: return 2;

	default:  return '0';}
}

int czz(i) int i; {
  switch (i) {
	case '0': return '1';
	case '1': return '2'; 
	case '2': return '0';
	case '3': return '3';

	case 0: return 1;
	case 1: return 2; 
	case 2: return 0;
	case 3: return 3;

	default:  return '0';}
}

int zcc(i) int i; {
  switch (i) {
	case '0': return '2';
	case '1': return '0'; 
	case '2': return '1';
	case '3': return '3';

	case 0: return 2;
	case 1: return 0; 
	case 2: return 1;
	case 3: return 3;

	default:  return '0';}
}

/* create the rule defined by the "symmetric rule" panel */
- symRule:sender {
int j00, j01, j02, j10, j11, j12, j20, j21, j22;
int i0, i1, i2, j0, j1, r;
j00=[[S00 selectedCell] tag];
j01=[[S01 selectedCell] tag];
j02=[[S02 selectedCell] tag];
j10=[[S10 selectedCell] tag];
j11=[[S11 selectedCell] tag];
j12=[[S12 selectedCell] tag];
j20=[[S20 selectedCell] tag];
j21=[[S21 selectedCell] tag];
j22=[[S22 selectedCell] tag];
printf("%d, %d, %d, %d, %d, %d, %d, %d, %d\n",
	j00,j01,j02,j10,j11,j12,j20,j21,j22);
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) for (i2=0; i2<KK; i2++) {
    j0=KK+i1-i0;
    j1=KK+i2-i1;
    r =j00+j0*(j10+j0*j20)+j1*(j01+j1*j20);
    r+=j0*j1*(j11+j0*j21+j1*j12);
    r+=j0*j0*j1*j1*j22;
    switch([[sIncr selectedCell] tag]) {
      case 0: r+=i0; break;
      case 1: r+=i1; break;
      case 2: r+=(KK-i0)+(KK-i1); break;
      case 3: break;
      default: break;}
    ascrule[i2][i1][i0]=r%KK+'0';
    }
  [self setAllRules: self];
  return self;
  }



-readWRule:sender 
{char *c; int l;
 c=[sender stringValue];
if (c)  l=strlen(c);
 if(l>(KK*KK*2)) {[ruleNumber setStringValue: " - Exceeded - "]; return self;}
 if(longwolftoasc(c)) [self setAllRules:self];
  else [ruleNumber setStringValue: " - Invalid - "];
return self;
}

int longwolftoasc (char *c) {
  char  e; int i, l, n, i0,k1,k2,a,d[32],i1,u;
   a=0;     
 l=strlen(c);
   k1=k2=n=0; 
  for (i=0; i<(KK*KK*2); i++) d[i]=0;
  for (i=0; i<l; i++) {
    e=c[i];	
         if ('0' <= e  &&  e <= '9') n=e-'0';
    else if ('a' <= e  &&  e <= 'f') n=e-'a'+10;
    else if ('A' <= e  &&  e <= 'F') n=e-'A'+10;
    else   return FALSE;
    d[32-l+i]=n;   
//   			printf("\n e=%c caracter=%c  n=%d  i=%d",e,c[i],n,i);
 }
	//	for (i=0; i<(KK*2); i++) printf("es d[%d]=%d\n",i,d[i]);
 /* for (i0=0; i0<(KK*KK*2); i0++) {
    n=d[32-i0-1];  
    		ascrule[k1][k2][a]='0'+n%KK; n/=KK;   a++;  
    		ascrule[k1][k2][a]='0'+n%KK;     a++;
		ascrule[k1][k2][a]='0'+n%KK;  	k2++;
                          printf("es C[%d]=%c\n",i0,c[i0]);
      }*/

 for (i0=0; i0<KK; i0++) 
	for (i1=0; i1<KK; i1++){ 
	   u=KK*KK*2-i0*KK*2-i1*2-1;	
 	   n=d[u];
	   ascrule[i0][i1][0]='0'+n%KK; n/=KK;
	   ascrule[i0][i1][1]='0'+n%KK;
 	   n=d[u-1];
	   ascrule[i0][i1][2]='0'+n%KK; n/=KK;
	   ascrule[i0][i1][3]='0'+n%KK;
	  
    }


   //c[32]=0;
				// for (i=0; i<KK; i++) for(i0=0; i0<KK; i0++) 	   
			// printf("ascrule[%d][%d] = %d \n",i,i0, ascrule[i][i0]);    
return 1;
}


- setRule:sender 
{char ch[33]; int i, ii, j, jj, i0, i1, i2;
   wru(ch);
   [ruleNumber setStringValue: ch];
   ii= [sender selectedRow];
   jj=j= [sender selectedCol];
  i2=j%KK; j/=KK;
  i1=j%KK; j/=KK;
  i0=j%KK; j/=KK;
  ascrule[i0][i1][i2]='0'+ii;
  for (i=0; i<KK; i++) [[ascru cellAt: i: jj] setIntValue: NO];
  [[ascru cellAt: ii: jj] setIntValue: YES];
  [self setAllRules: self];
  return self;
}

- setAllRules:sender 
{char ch[WNML]; int i, j, i0, i1, i2;
   wru(ch);
   [ruleNumber setStringValue: ch];
//   printf("en setAllrule ruleNumber es ch=%s\n",ch);
   asctobin();
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) for (i2=0; i2<KK; i2++) {
    j=KK*(KK*i0+i1)+i2;
    for (i=0; i<KK; i++) {
      [[ascru cellAt: i: j] setIntValue: NO];
      if (auxrule[i0][i1][i2]) [[ascru cellAt: i: j] setEnabled: NO];
      if (auxrule[i0][i1][i2]) [[ascru cellAt: i: j] setBordered: NO];
      }
    [[ascru cellAt: binrule.three[i0][i1][i2]: j] setIntValue: YES];
    }
//   for (i0=0; i0<KK; i0++) for(i1=0; i1<KK; i1++) for (i2=0; i2<KK; i2++)	   
//	printf("binrule[%d][%d][%d] = %c\n",i0,i1,i2 ,ascrule[i0][i1][i2]);

   wru(ch);
   [ruleNumber setStringValue: ch];
   [self nxasfreq];
   if      (istot()==1) [totlRef setStringValue: "Totalistic"]; 
   else if (isstot()==1) [totlRef setStringValue: "Semitotalistic"];
      else [totlRef setStringValue: "  "];
   [self showProbability: pSliders];
return self;
}

- freeAllRules:sender {
int i, j; 
    for (i=0; i<KK; i++) for (j=0; j<DS; j++) 
      [[[ascru cellAt: i: j] setEnabled:  YES] setBordered: YES];
    auxzero();
return self;
}

- zeroRules:sender {
  asczero();
  auxzero();
  [self setAllRules: self];
return self;
}

- ranRules:sender {
  granrule();
  [self setAllRules: self];
return self;
}

- ranPRules:sender {
  granprule();
  [self setAllRules: self];
return self;
}

/* for 4-state automata, group the neighborhoods by twos and  */
/* use ASCII letters base 16 - that is, 0-9, A-F.	      */
void wru(c) char *c; {wrru(c,ascrule);}

/* calculate wru from an argument ascii rule  */
void wrru(c,ru) char *c, ru[KK][KK][KK]; {
int  i, i0, i1;
for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) {
  i= 4*(ru[i0][i1][1]-'0')+(ru[i0][i1][0]-'0')+'0';
  if (i>'9') i=i+('A'-':');
  c[WNML-2*(KK*i0+i1)-2]=i;
  i= 4*(ru[i0][i1][3]-'0')+(ru[i0][i1][2]-'0')+'0';
  if (i>'9') i=i+('A'-':');
  c[WNML-2*(KK*i0+i1)-3]=i;
  }
c[WNML-1]=0;
}


/* generate a random rule */
void granrule() {
 int i, i0, i1, i2;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++) {
  i=(random()&0xFF)%KK;
  ascrule[i0][i1][i2]=i+'0';
  }
}

/* generate a random protected rule */
void granprule() {int i0, i1, i2, i, j;
i=0; j=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++) {
  if (i%8 == 0) j=random(); i++;
  if (auxrule[i0][i1][i2]==0) ascrule[i0][i1][i2]='0'+j%KK;
  j/=KK;
  }
}

- showProbability:sender 
{int i; double pp, p[KK];
  for (i=0; i<KK; i++) p[i]=[[sender cellAt: i: 0] doubleValue];
  for (pp=0.0, i=0; i<KK; i++) pp+=p[i];
  for (i=0; i<KK; i++) {
    [[pSliders cellAt: i: 0] setDoubleValue: p[i]/pp];
    [[pWindows cellAt: i: 0] setDoubleValue: p[i]/pp];
    }
return self;
}

- randomLine:sender
{double p[KK]; int i;
  for (i=0; i<KK; i++) p[i]=[[pSliders cellAt:i:0] doubleValue];
  ranblin(p[0],p[1],p[2],p[3]);
return self;
}

- sCellLine:sender {putionj(1,0); return self;}

- uniformLine:sender {ranblin(0.25,0.25,0.25,0.25); return self;}

- useRECLine:sender {
  [RECPanel makeKeyAndOrderFront: sender];
  [RECValue setStringValue: "*"];
return self;
}

- runRECLine:sender {
printf("hello from runRec\n");
  [RECValue setStringValue: " "];
  if (rec([sender stringValue])) 
	[RECValue setStringValue: "T"]; else [RECValue setStringValue: "F"];
return self;
}

/* - - - - - - - - -   D E M O N S T R A T I O N   R U L E   - - - - - - - - */

- setDemo:sender 
{char ch[WNML];
   wru(ch);
   [ruleNumber setStringValue: ch];
  xtoasc(ascrule,[[sender selectedCell] tag]);
  [self setAllRules: self];
  return self;
}

/* - - - - - - - - - - -    P E R M U T E D   R U L E    - - - - - - - - - - */

- pmutRule: sender {
  asctobin();
  ptedbrul(&binrule,&binrule,[pRu intValue]);
  [self setAllRules:self];
return self;
}

void ptedbrul(pr,br,k) birular *pr, *br; int k; {
int i;
  for (i=0; i<KK*KK*KK; i++) pr->one[i]=permu[k][br->one[i]];
}

/* - - - - - - -   F R E D K I N   R E V E R S I B I L I T Y    - - - - - - */

- fredRev:sender {
int i0, i1, i2, i3, i4, i5;
  nutowo1([fredRule intValue]);
  if ([fredXor selectedRow]==0) {
    if ([fredDir selectedRow]==0) {
      for (i0=0; i0<2; i0++)
      for (i1=0; i1<2; i1++)
      for (i2=0; i2<2; i2++)
      for (i3=0; i3<2; i3++)
	    for (i4=0; i4<2; i4++)
	    for (i5=0; i5<2; i5++)
	    ascrule[2*i0+i1][2*i2+i3][2*i4+i5]=
		'0'+((prule1[4*i1+2*i3+i5]-'0')==i2?0:1)+2*i3;
      } else {
      for (i0=0; i0<2; i0++)
      for (i1=0; i1<2; i1++)
      for (i2=0; i2<2; i2++)
      for (i3=0; i3<2; i3++)
	    for (i4=0; i4<2; i4++)
	    for (i5=0; i5<2; i5++)
	    ascrule[2*i0+i1][2*i2+i3][2*i4+i5]=
		'0'+2*((prule1[4*i0+2*i2+i4]-'0')==i3?0:1)+i2;
      }
    } else {
    if ([fredDir selectedRow]==0) {
      for (i0=0; i0<2; i0++)
      for (i1=0; i1<2; i1++)
      for (i2=0; i2<2; i2++)
      for (i3=0; i3<2; i3++)
	    for (i4=0; i4<2; i4++)
	    for (i5=0; i5<2; i5++)
	    ascrule[2*i0+i1][2*i2+i3][2*i4+i5]=
		'0'+((prule1[4*i1+2*i3+i5]-'0')==i0?0:1)+2*i1;
      } else {
      for (i0=0; i0<2; i0++)
      for (i1=0; i1<2; i1++)
      for (i2=0; i2<2; i2++)
      for (i3=0; i3<2; i3++)
	    for (i4=0; i4<2; i4++)
	    for (i5=0; i5<2; i5++)
	    ascrule[2*i0+i1][2*i2+i3][2*i4+i5]=
		'0'+2*((prule1[4*i0+2*i2+i4]-'0')==i1?0:1)+i0;
      }
    }
  [self setAllRules:self];
return self;
}

/* ar = char array for fredkin 4h rule */
/* pr = char array holding 2h rule     */
/* i  = xor, xnor switch	       */
/* j  = forward, reverse switch	       */

void fredrule(ar,pr,i,j) char ar[KK][KK], pr[4]; int i, j; {
int i0, i1, i2, i3,i4,i5;
  for (i0=0; i0<2; i0++)
  for (i1=0; i1<2; i1++)
  for (i2=0; i2<2; i2++)
  for (i3=0; i3<2; i3++)
	    for (i4=0; i4<2; i4++)
	    for (i5=0; i5<2; i5++)
    if (i==0) 
      if (j==0) ar[2*i0+i1][2*i2+i3]='0'+((pr[2*i1+i3]-'0')==i0?0:1)+2*i1;
      else      ar[2*i0+i1][2*i2+i3]='0'+2*((pr[2*i0+i2]-'0')==i1?0:1)+i0;
    else 
      if (j==0) ar[2*i0+i1][2*i2+i3]='0'+((pr[2*i1+i3]-'0')==i2?0:1)+2*i3;
      else      ar[2*i0+i1][2*i2+i3]='0'+2*((pr[2*i0+i2]-'0')==i3?0:1)+i2;
}

/* - - - - - - - - - -   C O M P O S I T E   R U L E    - - - - - - - - - */

- compRule:sender {
int i, r;
int i0, i1, i2, i3, i4, i5;
    r=[[compFact cellAt: 0: 0] intValue];
    for (i=0; i<8; i++) {prule1[i]=r%2+'0'; r/=2;}
    r=[[compFact cellAt: 1: 0] intValue];
    for (i=0; i<8; i++) {prule2[i]=r%2+'0'; r/=2;}
    r=[[compFact cellAt: 2: 0] intValue];
    for (i=0; i<8; i++) {prule3[i]=r%2+'0'; r/=2;}
	    for (i0=0; i0<2; i0++)
	    for (i1=0; i1<2; i1++)
	    for (i2=0; i2<2; i2++)
	    for (i3=0; i3<2; i3++)
	    for (i4=0; i4<2; i4++)
	    for (i5=0; i5<2; i5++) {
	    ascrule[2*i0+i1][2*i2+i3][2*i4+i5]=
   2*((i3==0)?(prule1[4*i0+2*i2+i4]-'0'):(prule2[4*i0+2*i2+i4]-'0'))+
   (prule3[4*i1+2*i3+i5]-'0')+'0';
	    }
  [self setAllRules: self];
return self;
}

- reverseRule:sender {
int i, r;
int i0, i1, i2, i3, i4, i5;
    r=[revRule intValue];
    for (i=0; i<8; i++) {prule1[i]=r%2+'0'; r/=2;}
      switch ('M') {
	case 'M':				/* (2,1) rules with memory */
	    for (i0=0; i0<2; i0++)
	    for (i1=0; i1<2; i1++)
	    for (i2=0; i2<2; i2++)
	    for (i3=0; i3<2; i3++)
	    for (i4=0; i4<2; i4++)
	    for (i5=0; i5<2; i5++)
	    ascrule[2*i0+i1][2*i2+i3][2*i4+i5]=
		'0'+((prule1[4*i1+2*i3+i5]-'0')==i2?0:1)+2*i3;
	    break;
	case 'm':				/* (2,1) rules with memory */
	    for (i0=0; i0<2; i0++)
	    for (i1=0; i1<2; i1++)
	    for (i2=0; i2<2; i2++)
	    for (i3=0; i3<2; i3++)
	    for (i4=0; i4<2; i4++)
	    for (i5=0; i5<2; i5++)
	    ascrule[2*i0+i1][2*i2+i3][2*i4+i5]=
		'0'+2*((prule1[4*i0+2*i2+i4]-'0')==i3?0:1)+i2;
	    break;
	case 'N':				/* (2,1) rules with memory */
	    for (i0=0; i0<2; i0++)
	    for (i1=0; i1<2; i1++)
	    for (i2=0; i2<2; i2++)
	    for (i3=0; i3<2; i3++)
	    for (i4=0; i4<2; i4++)
	    for (i5=0; i5<2; i5++)
	    ascrule[2*i0+i1][2*i2+i3][2*i4+i5]=
		'0'+((prule1[4*i1+2*i3+i5]-'0')==i0?0:1)+2*i1;
	    break;
	case 'n':				/* (2,1) rules with memory */
	    for (i0=0; i0<2; i0++)
	    for (i1=0; i1<2; i1++)
	    for (i2=0; i2<2; i2++)
	    for (i3=0; i3<2; i3++)
	    for (i4=0; i4<2; i4++)
	    for (i5=0; i5<2; i5++)
	    ascrule[2*i0+i1][2*i2+i3][2*i4+i5]=
		'0'+2*((prule1[4*i0+2*i2+i4]-'0')==i1?0:1)+i0;
	    break;
	  }
return self;
}

/* - - - - - - - - -    C A R T E S I A N   P R O D U C T    - - - - - - - - */

- prodRule:sender {
int i, r;
int i0, i1, i2, i3, i4, i5;
    r=[[prodFact cellAt: 0: 0] intValue];
    for (i=0; i<8; i++) {prule1[i]=r%2+'0'; r/=2;}
    r=[[prodFact cellAt: 1: 0] intValue];
    for (i=0; i<8; i++) {prule2[i]=r%2+'0'; r/=2;}
	    for (i0=0; i0<2; i0++)
	    for (i1=0; i1<2; i1++)
	    for (i2=0; i2<2; i2++)
	    for (i3=0; i3<2; i3++)
	    for (i4=0; i4<2; i4++)
	    for (i5=0; i5<2; i5++) {
	    ascrule[2*i0+i1][2*i2+i3][2*i4+i5]=
		'0'+2*(prule1[4*i0+2*i2+i4]-'0')+(prule2[4*i1+2*i3+i5]-'0');
	    }
  [self setAllRules: self];
return self;
}

- life2N:sender {life2n(); return self;}

/* - - - - - - - - - -   P E R R Y ' S   R U L E S   - - - - - - - - - - - - */

- incrPerry:sender {
  perul++;
  if (perul>100) perul=1;
  perry(perul-1);
  [perryRule setIntValue: perul];
  [self setAllRules: self];
return self;
}

- decrPerry:sender {
  perul--;
  if (perul<1) perul=100;
  perry(perul-1);
  [perryRule setIntValue: perul];
  [self setAllRules: self];
return self;
}

- selectPerry:sender {
  perul=[sender intValue];
  perry(perul-1);
  [self setAllRules: self];
return self;
}

/* - - - - - - - - - - - - -   G F ( 4 )   R U L E   - - - - - - - - - - - - */

- setMCoeff:sender {int s, t;
    s=[sender selectedRow];
    t=[sender tag];
    gf3rule[t]=s+'0';
    [gfWindow setDocEdited:YES];
return self;
}

- setVCoeff:sender {int s, t;
    s=[sender selectedRow];
    t=[sender tag];
    gf3rule[t+9]=s+'0';
    [gfWindow setDocEdited:YES];
return self;
}

- setSCoeff:sender {int s;
    s=[sender selectedRow];
    gf3rule[12]=s+'0';
    [gfWindow setDocEdited:YES];
return self;
}

- enterGF3Rule:sender
{char b[10][10], c[80]; int i;
//   int i; for (i=0; i<13; i++) printf("%1d ",gf3rule[i]); printf("\n");
    gftoasc();
    i=gf3rule[0]-'0';
	 if (i==0) b[0][0]=0; else sprintf(b[0],"%dx^2+ ",i);
    i=(gf3rule[1]-'0'+gf3rule[3]-'0')%KK;
	 if (i==0) b[1][0]=0; else sprintf(b[1],"%dxy +",i);
    i=(gf3rule[2]-'0'+gf3rule[6]-'0')%KK;
	 if (i==0) b[2][0]=0; else sprintf(b[2],"%dxz +",i);
    i=gf3rule[4]-'0';
	 if (i==0) b[3][0]=0; else sprintf(b[3],"%dy^2+ ",i);
    i=(gf3rule[5]-'0'+gf3rule[7]-'0')%KK;
	 if (i==0) b[4][0]=0; else sprintf(b[4],"%dyz +",i);
    i=gf3rule[8]-'0';
	 if (i==0) b[5][0]=0; else sprintf(b[5],"%dz^2+ ",i);
    i=gf3rule[9]-'0';
	 if (i==0) b[6][0]=0; else sprintf(b[6],"%dx+ ",i);
    i=gf3rule[10]-'0';
	 if (i==0) b[7][0]=0; else sprintf(b[7],"%dy+",i);
    i=gf3rule[11]-'0';
	 if (i==0) b[8][0]=0; else sprintf(b[8],"%dz +",i);
    i=gf3rule[12]-'0';
	 if (i==0) b[9][0]=0; else sprintf(b[9],"%d",i);
    sprintf(c,"%s%s%s%s%s%s%s%s%s%s",b[0],b[1],b[2],b[3],b[4],b[5],b[6],
					b[7],b[8],b[9]);
    [ruleFormula setStringValue: c];
    [self setAllRules:self];
    [gfWindow setDocEdited:NO];
return self;
}

/* - - - - - - - -    S E M I T O T A L I S T I C   R U L E    - - - - - - - */
 
- setSemiState:sender {
  int s, t;
    s=[sender selectedRow];
    t=[sender tag];
    strule[t%KK][t/KK]=s+'0';
    [toWindow setDocEdited:YES];
    sttoasc();
  return self;
  }
 
- enterSemiRule:sender {
    sttoasc();
    [self setAllRules:self];
    [toRuleNumber setIntValue: totonu(0)];
    [stWindow setDocEdited:NO];
return self;
}

/* - - - - - - - - - -    T O T A L I S T I C   R U L E    - - - - - - - - - */

- setTotalisticState:sender {
  int s, t;
    s=[sender selectedRow];
    t=[sender tag];
    ttrule[t]=s+'0';
    [toWindow setDocEdited:YES];
  return self;
  }
 
- enterTotalisticRule:sender {
    totoasc();
    [self setAllRules:self];
    [toRuleNumber setIntValue: totonu(0)];
    [toWindow setDocEdited:NO];
return self;
}

/* - - - - - - - - - -    X E N O P H I L I C   R U L E    - - - - - - - - - */

/*
 *	subset  code
 *	------  ----
 *	empty - 0
 *	0	1
 *	1	2
 *	2	4
 *	0,1	3
 *	0,2	5
 *	1,2	6
 *	0,1,2	7
 *
 *     rule     --- phobic  -- philic  -- sphobic  -- sphilic
 *	000     0      (1)  1,2   (6)  0      (1)  1,2   (6)  
 *	001	0,1    (3)  2     (4)  0,1    (3)  2     (4)  
 *	002	0,2    (5)  1     (2)  0,2    (5)  1	 (2) 
 *	010	0,1    (3)  2     (4)  0      (1)  1,2   (6)  
 *	011	0,1    (3)  2     (4)  0,1    (3)  2     (4)  
 *	012	0,1,2  (7)  	  (0)  0,2    (5)  1	 (2) 
 *	020	0,2    (5)  1     (2)  0      (1)  1,2   (6)  
 *	021	0,1,2  (7)  	  (0)  0,1    (3)  2     (4)  
 *	022	0,2    (5)  1     (2)  0,2    (5)  1	 (2) 
 *	100	0,1    (3)  2     (4)  0,1    (3)  2     (4)  
 *	101	0,1    (3)  2     (4)  1      (2)  0,2   (5)  
 *	102	0,1,2  (7)  	  (0)  1,2    (6)  0	 (1) 
 *	110	0,1    (3)  2     (4)  0,1    (3)  2     (4)  
 *	111	1      (2)  0,2   (5)  1      (2)  0,2   (5)  
 *	112	1,2    (6)  0     (1)  1,2    (6)  0	 (1) 
 *	120	0,1,2  (7)        (0)  0,1    (3)  2     (4)  
 *	121	1,2    (6)  0     (1)  1      (2)  0,2   (5)  
 *	122	1,2    (6)  0     (1)  1,2    (6)  0	 (1) 	
 *	200	0,2    (5)  1     (2)  0,2    (5)  1	 (2) 	
 *	201	0,1,2  (7)  	  (0)  1,2    (6)  0	 (1) 
 *	202	0,2    (5)  1     (2)  2      (4)  0,1   (3)  
 *	210	0,1,2  (7)  	  (0)  0,2    (5)  1	 (2) 
 *	211	1,2    (6)  0     (1)  1,2    (6)  0	 (1) 
 *	212	1,2    (6)  0     (1)  2      (4)  0,1   (3)  
 *	220	0,2    (5)  1     (2)  0,2    (5)  1	 (2) 	
 *	221	1,2    (6)  0     (1)  1,2    (6)  0	 (1) 
 *	222	2      (4)  0,1   (3)  2      (4)  0,1   (3)  
 */ 

- xenophilic:sender {
  ranvachrul(xt);
  [self setAllRules: self];
return self;
}

int xepairs[6][2] = { {0,1}, {0,2}, {0,3}, {1,2}, {1,3}, {2,3} };
int xetrips[4][3] = { {1,2,3}, {0,2,3}, {0,1,3}, {1,2,3} };
int xeperms[6][3] = { {0,1,2}, {1,2,0}, {2,0,1}, {0,2,1}, {2,1,0}, {1,0,2} };

- xenophobic:sender 
{int i, j, k, i0, i1, i2, ix[2], jx[3]; char ru[6][2][2][2];

  for (i=0; i<6; i++) runowows(ru[i],[[obBnry cellAt: i: 0] intValue]);
  for (i=0, k=0; i<6; i++) if (ru[i][0][0][0]==ru[i][1][1][1]) 
	{[[obBnry cellAt: i: 0] setStringValue: "***"]; k=1;}
  if (k==1) return self;

  ascrule[0][0][0]='0';
  ascrule[1][1][1]='1';
  ascrule[2][2][2]='2';
  ascrule[2][2][2]='3';

  for (i=0; i<6; i++) {
    ix[0]=xepairs[i][0];
    ix[1]=xepairs[i][1];
    for (i0=0; i0<2; i0++) for (i1=0; i1<2; i1++) for (i2=0; i2<2; i2++) 
	ascrule[ix[i0]][ix[i1]][ix[i2]]=ix[ru[i][i0][i1][i2]-'0']+'0';
    }

  for (i=0; i<4; i++) {
    k=[[obTnry cellAt: i: 0] intValue];
    for (j=0; j<6; j++) {
      jx[0]=xetrips[i][xeperms[j][0]];
      jx[1]=xetrips[i][xeperms[j][1]];
      jx[2]=xetrips[i][xeperms[j][2]];
      ascrule[jx[0]][jx[1]][jx[2]]=xetrips[i][k%3]+'0';
      k/=3;
      }
    }

  [self setAllRules: self];
return self;
}

- randphobic:sender {
  ranvachrul(xq);
  [[obBnry cellAt: 0: 0] setIntValue: (random()%64)*2+128];
  [[obBnry cellAt: 1: 0] setIntValue: (random()%64)*2+128];
  [[obBnry cellAt: 2: 0] setIntValue: (random()%64)*2+128];
  [[obBnry cellAt: 3: 0] setIntValue: (random()%64)*2+128];
  [[obBnry cellAt: 4: 0] setIntValue: (random()%64)*2+128];
  [[obBnry cellAt: 5: 0] setIntValue: (random()%64)*2+128];

  [[obTnry cellAt: 0: 0] setIntValue: random()%243];
  [[obTnry cellAt: 1: 0] setIntValue: random()%243];
  [[obTnry cellAt: 2: 0] setIntValue: random()%243];
  [[obTnry cellAt: 3: 0] setIntValue: random()%243];
return self;
}

int ran2of3(a,b) int a, b; {
if ((random()%1001)<500) return a; else return b;
}

int ran3of3(a,b,c) int a, b, c; {
if ((random()%1001)<333) return a;
if ((random()%1001)<667) return b;
return c;
}

/* generate a random variable choice rule */
void ranvachrul(c) char *c; {int i0, i1, i2, i;
i=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++) {
  switch (c[KK*(KK*i0+i1)+i2]-'0') {
    case 0: break;
    case 1: i=0; break;
    case 2: i=1; break;
    case 4: i=2; break;
    case 3: i=ran2of3(0,1); break;
    case 6: i=ran2of3(1,2); break;
    case 5: i=ran2of3(2,0); break;
    case 7: i=ran3of3(0,1,2); break;
    default: i=0; break;}
    ascrule[i0][i1][i2]='0'+i;
  }
}

/*
- allClans:sender 
{int i, j, k, i0, i1, i2, i3, i4, i5, ix[2];
char ru[3][2][2][2], ch[WNML];
char ii[WNML][KK][KK][KK], wnum[RSYM][WNML];
  for (i=0; i<(KK*(KK-1))/2; i++) runowows(ru[i],150);
  ascrule[0][0][0]='0';
  ascrule[1][1][1]='1';
  ascrule[2][2][2]='2';
  ix[0]=0; ix[1]=1;
  for (i0=0; i0<2; i0++) for (i1=0; i1<2; i1++) for (i2=0; i2<2; i2++) 
	ascrule[ix[i0]][ix[i1]][ix[i2]]=ix[ru[0][i0][i1][i2]-'0']+'0';
  ix[0]=2; ix[1]=0;
  for (i0=0; i0<2; i0++) for (i1=0; i1<2; i1++) for (i2=0; i2<2; i2++) 
	ascrule[ix[i0]][ix[i1]][ix[i2]]=ix[ru[1][i0][i1][i2]-'0']+'0';
  ix[0]=1; ix[1]=2;
  for (i0=0; i0<2; i0++) for (i1=0; i1<2; i1++) for (i2=0; i2<2; i2++) 
	ascrule[ix[i0]][ix[i1]][ix[i2]]=ix[ru[2][i0][i1][i2]-'0']+'0';
  j=0;
  for (i0=0; i0<KK; i0++) 
  for (i1=0; i1<KK; i1++) 
  for (i2=0; i2<KK; i2++) 
  for (i3=0; i3<KK; i3++) 
  for (i4=0; i4<KK; i4++) 
  for (i5=0; i5<KK; i5++) {
     ascrule[0][1][2]=i0+'0';
     ascrule[0][2][1]=i1+'0';
     ascrule[1][0][2]=i2+'0';
     ascrule[1][2][0]=i3+'0';
     ascrule[2][0][1]=i4+'0';
     ascrule[2][1][0]=i5+'0';
     k=allperm(wnum,ii,ascrule);
     wru(ch);
     printf("%3d: %s   %s\n",++j,ch,wnum[k]);
    }
return self;
}
*/


/* - - - - - - - - -    E Q U I V A L E N C E   R U L E    - - - - - - - - - */
/*
- equivalence:sender 
{char ru[2][2][2], iy[2], iz; int i, i0, i1, i2, ix[KK], choi, p;
  runowows(ru,[eqFactor intValue]);
  choi=[eqChoices intValue];
  p=[eqPair selectedRow];
  switch (p) {
    case 0:  ix[0]=0; ix[1]=0; ix[2]=1;
	     iy[0]='0'; iy[1]='1';
	     iz='2'; break;
    case 1:  ix[0]=0; ix[1]=1; ix[2]=0;
	     iy[0]='0'; iy[1]='2';
	     iz='1'; break;
    case 2:  ix[0]=1; ix[1]=0; ix[2]=0;
	     iy[0]='1'; iy[1]='2';
	     iz='0'; break;
    default: printf("unidentified pair\n"); break;}
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) for (i2=0; i2<KK; i2++) {
    i=ru[ix[i0]][ix[i1]][ix[i2]];
    ascrule[i0][i1][i2]=(i=='0'?iy[choi%2]:iz);
    choi/=2;
    }
  [self setAllRules: self];
return self;
}
*/
- ranqul:sender {
  switch ([sender selectedRow]) {
    case 0: [eqFactor setIntValue: random()%256]; break;
    case 1: [eqChoices setIntValue: random()%256]; break;
    default: printf("unidentified random choice\n"); break;}
return self;
}

/* - - - - - - - - - - -   D E S I G N E D   R U L E   - - - - - - - - - - - */

- deZign:sender 
{int k, n, i0, i1, i2;
    k=[sender intValue];
    if (k>=0 && k <=KK) return self;
    k=[sender tag];
    i2=k%KK; k/=KK;
    i1=k%KK; k/=KK;
    i0=k%KK;
    switch ([designRef selectedRow]) {
      case 0: k=i0; break;
      case 1: k=i1; break;
      case 2: k=i2; break;
      default: k=0; break;}
    n=[designPrm selectedRow];
    k=permut(k,n);
    [sender setIntValue: k];
    [ddWindow setDocEdited:YES];
return self;
}

- clearDesign:sender {
id  z;
int i;
  for (i=0, z=zeZeZe; i<DS; i++, z=[z nextText]) [z setIntValue: KK];
return self;
}

- copyToDesign:sender {
id  z;
int i0, i1, i2;
  z=zeZeZe;
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) for (i2=0; i2<KK; i2++) {
    [z setIntValue: ascrule[i0][i1][i2]-'0'];
    z=[z nextText];
    }    
return self;
}

- enterDesign:sender {
int i, k, i0, i1, i2;
id  z;
  for (i=0, z=zeZeZe; i<DS; i++, z=[z nextText]) {
    k=i;
    i2=k%KK; k/=KK;
    i1=k%KK; k/=KK;
    i0=k%KK;
    k=[z intValue];
    ascrule[i0][i1][i2]=(k<KK?k:0)+'0';
    auxrule[i0][i1][i2]=(k<KK?1:0);
    }
  [self setAllRules: self];
  [ddWindow setDocEdited:NO];
return self;
}

/* - - - - - - - - - - - -  D A T A   D I S P L A Y  - - - - - - - - - - - - */

- symMetr:sender {
char ii[RSYM][KK][KK][KK], wnum[RSYM][WNML];
int i, l;
  l=allperm(wnum,ii,ascrule);
  [self showDataText: "Symmetry\n Class:\n\n"];
  for (i=0; i<RSYM; i++) {
    [self showDataText: wnum[i]];
    [self showDataText: "\n"];
    }
  [dataText setSel: 9*l+18: 9*(l+1)+18];
return self;
}

- perMute:sender {
char    c[WNML], d[WNML];
int     i, k;
birular ru;
  wrru(d,ascrule);
  asctobin();
  ru=binrule;
  [self showDataText: "Permuted\n Values:\n\n"];
  for (i=0, k=0; i<24; i++) {
    ptedbrul(&binrule,&ru,i);
    bintoasc();
    wrru(c,ascrule);
    if (strcmp(c,d)<0) {strcpy(d,c); k=i;}
    [self showDataText: c];
    [self showDataText: "\n"];
    }
  [dataText setSel: 9*k+19: 9*(k+1)+19];
return self;
}

- showDataText:(char *)ch
{int tl;
  tl=[dataText textLength];
  [dataText setSel: tl: tl];
  [dataText replaceSel:  ch];
  [dataText scrollSelToVisible];
  [dataText display];
return self;
}

void clumin(c) char *c; {
char d[WNML], ii[RSYM][KK][KK][KK], wnum[RSYM][WNML];
int i, j, l;
  wrru(c,ascrule);
  l=allperm(wnum,ii,ascrule);
  for (j=0; j<RSYM; j++) {
    for (i=0; i<24; i++) {
      chrucopy(ascrule,ii[j],'w');
      asctobin();
      ptedbrul(&binrule,&binrule,i);
      bintoasc();
      wrru(d,ascrule);
      if (strcmp(d,c)<0) strcpy(c,d);
      }
    }
}

/* fill ascrule from binrule */
void bintoasc()
{int i0, i1, i2;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
    ascrule[i0][i1][i2]=binrule.three[i0][i1][i2]+'0';
}

/* - - - - - - - - - - - -  T R I V I A   P A N E L  - - - - - - - - - - - - */

/* graph the frequencies of ascrule 		 */
/* put dot at coordinates (u,v)			 */
/* percentages evolving into each value		 */
/* percentages shifting - adds to more than 100% */
/* entropy and Langton's lambda = % nonquiescent */

- nxasfreq {
int    i, j, i0, i1, i2;
int    stat[KK], stal, stac, star;		/* statistic counts */
int    xe;
double staf[KK], t, pp;

xe=0;
pp=1.0/((double)(DS));
stal=0; stac=0; star=0;
for (i=0; i<KK; i++) stat[i]=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++) {
  j=ascrule[i0][i1][i2]-'0';
  stat[j]++;
  if (j==i0) stal++;
  if (j==i1) stac++;
  if (j==i2) star++;
  if (j==i0 || j==i1 || j==i2) xe++;
  }
for (i=0; i<KK; i++) staf[i]=((double)stat[i])*pp;
for (i=0; i<KK; i++) [[statState cellAt: 0: i] setDoubleValue: staf[i]];
	[statIndx setDoubleValue: ((double)stal)*pp at: 0];
	[statIndx setDoubleValue: ((double)stac)*pp at: 1];
	[statIndx setDoubleValue: ((double)star)*pp at: 2];
for (i=0, t=0.0; i<KK; i++) t+=staf[i]*log(staf[i]);
	[statLamb setDoubleValue: 1.0-staf[0]];
	[statEntro setDoubleValue: -t/log((double)KK)];
[statXeno  setDoubleValue: ((double)(DS-xe))*pp at: 0];
[statXeno  setDoubleValue: ((double)xe)*pp at: 1];
return self;
}

@end

/* end RulePanel.m */
