
/* nxlcau41.h			*/
/* header file for nxlcau41.c	*/
/* 12 May 1989			*/

# define COLGRAF      4  /* graph resolution			*/
# define T80X25       3  /* text resolution			*/
# define SRR	     16  /* row of semitotalistic rule number	*/
# define SRC	     56  /* column of s-totalistic rule number	*/
# define TRR	     16  /* row showing totalistic rule number	*/
# define TRC	     56  /* column for totalistic rule number	*/
# define XRR	     12  /* row displaying totalistic rule	*/
# define XRC	     56  /* column for totalistic rule		*/
# define WHCYMAG      1  /* color quad for normal screen	*/
# define YELREGR      2  /* color quad for alternative		*/
# define AL         320  /* array length (screen width)		*/
# define SL	     40	 /* short array length			*/
# define KK	      4  /* number of states per cell		*/
# define RR	      3  /* length of neighborhood = 2r+1	*/ 
# define DS  (KK*KK*KK)  /* 2^RR (distinct neighborhoods)	*/
# define DN     (KK*KK)	 /* number of distinct nodes		*/
# define DDN      65536  /* max de Bruijn diagram nodes 	*/
# define PDN        256  /* pair diagram nodes = KK^4r		*/
# define SDN    16*4096  /* subset diagram nodes = 2^(KK^2r)	*/	   
# define TS RR*(KK-1)+1  /* distinct sums w/totalistic rule	*/

# define XAN	     52	/* nominal max number of ancestors/node	*/

# define K2     (KK*KK) 
# define K3     (KK*KK*KK) 
# define K4	(K2*K2)
# define K5	(K2*K3)
# define K6	(K3*K3)
# define K8	(K4*K4)
# define AV	(KK*KK)
# define SS     ((RR-1)*(KK-1)+1)

# define HH		60	/* points in histogram */

# define RSYM		48	/* number of rule symmetries = 2*k!	*/
# define WNML	        33	/* arry size to hold hex wolfram number */

# define CCY          6		/* circumference of max length cycle	*/
# define XCY	   4096		/* max number of cycles = KK^CCY	*/

# define CLEN 300	/* buffer length for rec source     */
# define PLEN 900	/* buffer length for rec object     */
# define XLEN 128	/* buffer length for rec predefined */
# define NY    24

typedef union birular {
	int one[KK*KK*KK];
	int three[KK][KK][KK];
	} birular;
typedef union parneih {
	int one[K4];
	int two[K2][K2];
	int four[KK][KK][KK][KK];
	} parneih;
typedef union twoparn {
	int one[K8];
	int two[K4][K4];
	int eight[KK][KK][KK][KK][KK][KK][KK][KK];
	} twoparn;

/* end nxlcau41.h */
